#include <Servo.h>
Servo myservo;
#define LIMIT 5
#define PHOT_PIN A0
int llum;
int pos = 0;    // variable to store the servo position
int servoPin = 9;
int angleArray[4] = {10, 75, 125, 180};
float servoPosition;

#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"
//define pins numbers
const int trigPin = 2;
const int echoPin = 3;
//define variables
long duration;
int distance;
boolean repeticio1 = false;
boolean repeticio2 = false;

SoftwareSerial mySoftwareSerial(10, 11); // RX, TX
DFRobotDFPlayerMini myDFPlayer;


void setup() {
  myservo.attach(servoPin);  // attaches the servo on pin 9 to the servo object
  Serial.begin(9600);
  pinMode(PHOT_PIN, INPUT);

  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  pinMode (4, OUTPUT);

  mySoftwareSerial.begin(9600);
  Serial.begin(115200);
  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    Serial.println(F("Unable to begin:"));
    Serial.println(F("1.Please recheck the connection!"));
    Serial.println(F("2.Please insert the SD card!"));
    while (true) {
      delay(0); // Code to compatible with ESP8266 watch dog.
    }
  }
  Serial.println(F("DFPlayer Mini online."));

  myDFPlayer.volume(30);  //Set volume value. From 0 to 30
  myDFPlayer.play(1);  //Play the first mp3
}


void loop() {

  llum = analogRead (PHOT_PIN);
  /*
    if (llum < LIMIT) {
      for (pos = 0; pos <= 180; pos += 1) { // goes from 0 degrees to 180 degrees
        // in steps of 1 degree
        myservo.write(pos);              // tell servo to go to position in variable 'pos'
        delay(15);                       // waits 15ms for the servo to reach the position
      }

      for (pos = 180; pos >= 0; pos -= 1) { // goes from 180 degrees to 0 degrees
        myservo.write(pos);              // tell servo to go to position in variable 'pos'
        delay(15);                       // waits 15ms for the servo to reach the position
      }
  */

  int pos = floor(random(4));
  servoPosition = angleArray[pos];

  if (llum < LIMIT) {
    myservo.write(servoPosition);
    delay(2500);
    myservo.write(90);
  } else {
    myservo.write(90);
  }
  Serial.println(analogRead(A0));
  delay (100);

  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2;
  // Prints the distance on the Serial Monitor
  Serial.print("Distance: ");
  Serial.println(distance);


  // si la distancia es més petita que 80 sona la primera pista
  if (30 <= distance && distance <= 80) {
    if (!repeticio1) {
      myDFPlayer.play(1);
      repeticio1 = true; //Play the first mp3
      repeticio2 = false;
        digitalWrite (4, HIGH);
    }
  } else if (0 <= distance && distance < 30) {
    if (!repeticio2) {
      myDFPlayer.play(2);
      repeticio2 = true; //Play the second mp3
      repeticio1 = false;
        digitalWrite (4, LOW);
    }
  } else {
    myDFPlayer.pause();
    repeticio2 = false;
    repeticio1 = false;
  }
}
